Imports System
Imports System.Text
Imports System.Net.Sockets
Imports System.IO
Imports System.Globalization

Public Class Program

    Shared Function IC() As IFormatProvider
        Return CultureInfo.InvariantCulture
    End Function

    Shared Function Parse(ByVal X As String, ByVal Y As String) As Koordinate
        Return New Koordinate(Integer.Parse(X, IC), Integer.Parse(Y, IC))
    End Function

    Shared Function Pojej(ByVal Zakladi() As Koordinate, ByVal K As Koordinate) As Koordinate()
        Dim Z As Integer = 0
        Dim I As Integer
        For I = 0 To Zakladi.Length - 1
            If Not ((Zakladi(I).X = K.X) And (Zakladi(I).Y = K.Y)) Then
                Z = Z + 1
            End If
        Next I
        Dim T As Integer = 0
        Dim Rz(Z - 1) As Koordinate
        For I = 0 To Zakladi.Length - 1
            If Not ((Zakladi(I).X = K.X) And (Zakladi(I).Y = K.Y)) Then
                Rz(T) = Zakladi(I)
                T = T + 1
            End If
        Next I
        Return Rz
    End Function

    Shared Sub EventLoop(ByVal Cli As TcpClient, ByVal Reader As StreamReader, ByVal Writer As StreamWriter)
        Try
            Dim T As Lovec, Cmd As String, CmdA() As String, Delimiter() As Char = New Char() {" "}
            While True
                Cmd = Reader.ReadLine()
                CmdA = Cmd.Split(Delimiter)
                If CmdA(0) = "ADIJO" Then Return
                If CmdA(0).StartsWith("KONEC_IGRE") Then GoTo [Continue]
                If CmdA(0) <> "ZBUDI_SE" Then Throw New Exception("Napaka pri komunikaciji s streznikom.")

                Dim CmdI(CmdA.Length - 2) As Integer
                Dim I As Integer
                For I = 0 To CmdI.Length - 1
                    CmdI(I) = Integer.Parse(CmdA(I + 1))
                Next I

                Dim Zakladi(CmdI(1) - 1) As Koordinate
                For I = 0 To Zakladi.Length - 1
                    Zakladi(I) = New Koordinate(CmdI(6 + 2 * I), CmdI(6 + 2 * I + 1))
                Next I

                Dim J0 As Koordinate = New Koordinate(CmdI(2), CmdI(3))
                Dim N0 As Koordinate = New Koordinate(CmdI(4), CmdI(5))

                T = New Lovec
                T.ZbudiSe(CmdI(0), CmdI(1), J0, N0, Zakladi)

                Writer.WriteLine("BUDEN")

                While True
                    Cmd = Reader.ReadLine()
                    CmdA = Cmd.Split(Delimiter)
                    If CmdA(0) = "ADIJO" Then Return
                    If CmdA(0) = "KONEC_IGRE" Then
                        T.KonecIgre()
                        T = Nothing
                        Exit While
                    ElseIf CmdA(0) = "QV" Then
                        Dim J As Koordinate = Parse(CmdA(1), CmdA(2))
                        Dim N As Koordinate = Parse(CmdA(3), CmdA(4))
                        Zakladi = Pojej(Zakladi, J)
                        Zakladi = Pojej(Zakladi, N)
                        Dim dx As Integer = 0, dy As Integer = 0
                        T.KamGres(J, N, Zakladi, dx, dy)
                        Writer.WriteLine("QVR " & dx.ToString() & " " & dy.ToString())
                    Else
                    End If
                End While
[Continue]:
            End While
        Catch ex As Exception
            Console.WriteLine("Napaka: " & ex.ToString())
        End Try
    End Sub

    Shared Function Connect(ByVal HostName As String, ByRef Reader As StreamReader, ByRef Writer As StreamWriter) As TcpClient
        Dim Client As TcpClient = New TcpClient(HostName, 1175)
        Reader = New StreamReader(Client.GetStream())
        Writer = New StreamWriter(Client.GetStream())
        Writer.AutoFlush = True

        Dim Server As String = Reader.ReadLine()
        Console.WriteLine(Server)

        Writer.WriteLine("AVE " & Lovec.Ime)
        Dim Succ As String = Reader.ReadLine()
        If Succ <> "PRIJAVA USPESNA" Then Throw New Exception("Prijava na streznik neuspesna: " & Succ)
        Return Client
    End Function

    Shared Sub Main(ByVal Args() As String)
        Dim HostName As String
        If Args.Length < 2 Then HostName = "localhost" _
        Else HostName = Args(1)

        Dim Reader As StreamReader, Writer As StreamWriter
        Dim Client As TcpClient = Connect(HostName, Reader, Writer)
        EventLoop(Client, Reader, Writer)
    End Sub

End Class

Public Class Koordinate
    Public X As Integer, Y As Integer
    Public Sub New(ByVal X_ As Integer, ByVal Y_ As Integer)
        X = X_
        Y = Y_
    End Sub
End Class
